<?php

/**
 * inf_fech_bonif_servicio actions.
 *
 * @package    nomina
 * @subpackage inf_fech_bonif_servicio
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_fech_bonif_servicioActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by fecha_bonifica, num_doc ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
//            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select tab0.*

from
(

select
tab1.id_bonifica_servicios,
tab1.id_tipo_doc,
tab1.num_doc,
tab1.fecha_ingresa,
tab1.fecha_bonifica,
tab1.estado,
tab1.id_periodo,
tab2.nombre_apellido,
tab2.nombre_completo,
tab3.periodo,
tab4.codigo,
tab4.descripcion,
nom.fecha_ingreso

from no_bonifica_servicios tab1

left join no_datos_funcionario_v tab2
on tab1.id_tipo_doc = tab2.id_tipo_doc
and tab1.num_doc = tab2.num_doc

left join no_periodo_v tab3
on tab3.id_periodo = tab1.id_periodo

left join (
   select concep.* from
   no_conceptos_v concep
   where concep.id_concep_nomina = (select id_concep_bonif from no_param_concep where rownum = 1)
)tab4
on 1 = 1

left join no_nombramiento_v nom
on nom.id_tipo_doc = tab1.id_tipo_doc
and nom.num_doc = tab1.num_doc

) tab0

where
tab0.fecha_bonifica between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*

from
(

select
tab1.id_bonifica_servicios,
tab1.id_tipo_doc,
tab1.num_doc,
tab1.fecha_ingresa,
tab1.fecha_bonifica,
tab1.estado,
tab1.id_periodo,
tab2.nombre_apellido,
tab2.nombre_completo,
tab3.periodo,
tab4.codigo,
tab4.descripcion,
nom.fecha_ingreso

from no_bonifica_servicios tab1

left join no_datos_funcionario_v tab2
on tab1.id_tipo_doc = tab2.id_tipo_doc
and tab1.num_doc = tab2.num_doc

left join no_periodo_v tab3
on tab3.id_periodo = tab1.id_periodo

left join (
   select concep.* from
   no_conceptos_v concep
   where concep.id_concep_nomina = (select id_concep_bonif from no_param_concep where rownum = 1)
)tab4
on 1 = 1

left join no_nombramiento_v nom
on nom.id_tipo_doc = tab1.id_tipo_doc
and nom.num_doc = tab1.num_doc

) tab0

where
tab0.fecha_bonifica between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_fech_bonif_servicio] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by fecha_bonifica, num_doc ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
//            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

'Cantidad: ' || count(*) as periodo

FROM (  

select tab0.*

from
(

select
tab1.id_bonifica_servicios,
tab1.id_tipo_doc,
tab1.num_doc,
tab1.fecha_ingresa,
tab1.fecha_bonifica,
tab1.estado,
tab1.id_periodo,
tab2.nombre_apellido,
tab2.nombre_completo,
tab3.periodo,
tab4.codigo,
tab4.descripcion

from no_bonifica_servicios tab1

left join no_datos_funcionario_v tab2
on tab1.id_tipo_doc = tab2.id_tipo_doc
and tab1.num_doc = tab2.num_doc

left join no_periodo_v tab3
on tab3.id_periodo = tab1.id_periodo

left join (
   select concep.* from
   no_conceptos_v concep
   where concep.id_concep_nomina = (select id_concep_bonif from no_param_concep where rownum = 1)
)tab4
on 1 = 1

) tab0

where
tab0.fecha_bonifica between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
$sortBy

)
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);

            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
